# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class IoK8sApimachineryPkgApisMetaV1StatusCause(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, field: str=None, message: str=None, reason: str=None):  # noqa: E501
        """IoK8sApimachineryPkgApisMetaV1StatusCause - a model defined in Swagger

        :param field: The field of this IoK8sApimachineryPkgApisMetaV1StatusCause.  # noqa: E501
        :type field: str
        :param message: The message of this IoK8sApimachineryPkgApisMetaV1StatusCause.  # noqa: E501
        :type message: str
        :param reason: The reason of this IoK8sApimachineryPkgApisMetaV1StatusCause.  # noqa: E501
        :type reason: str
        """
        self.swagger_types = {
            'field': str,
            'message': str,
            'reason': str
        }

        self.attribute_map = {
            'field': 'field',
            'message': 'message',
            'reason': 'reason'
        }
        self._field = field
        self._message = message
        self._reason = reason

    @classmethod
    def from_dict(cls, dikt) -> 'IoK8sApimachineryPkgApisMetaV1StatusCause':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The io.k8s.apimachinery.pkg.apis.meta.v1.StatusCause of this IoK8sApimachineryPkgApisMetaV1StatusCause.  # noqa: E501
        :rtype: IoK8sApimachineryPkgApisMetaV1StatusCause
        """
        return util.deserialize_model(dikt, cls)

    @property
    def field(self) -> str:
        """Gets the field of this IoK8sApimachineryPkgApisMetaV1StatusCause.

        The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.  Examples:   \"name\" - the field \"name\" on the current resource   \"items[0].name\" - the field \"name\" on the first array entry in \"items\"  # noqa: E501

        :return: The field of this IoK8sApimachineryPkgApisMetaV1StatusCause.
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field: str):
        """Sets the field of this IoK8sApimachineryPkgApisMetaV1StatusCause.

        The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.  Examples:   \"name\" - the field \"name\" on the current resource   \"items[0].name\" - the field \"name\" on the first array entry in \"items\"  # noqa: E501

        :param field: The field of this IoK8sApimachineryPkgApisMetaV1StatusCause.
        :type field: str
        """

        self._field = field

    @property
    def message(self) -> str:
        """Gets the message of this IoK8sApimachineryPkgApisMetaV1StatusCause.

        A human-readable description of the cause of the error.  This field may be presented as-is to a reader.  # noqa: E501

        :return: The message of this IoK8sApimachineryPkgApisMetaV1StatusCause.
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message: str):
        """Sets the message of this IoK8sApimachineryPkgApisMetaV1StatusCause.

        A human-readable description of the cause of the error.  This field may be presented as-is to a reader.  # noqa: E501

        :param message: The message of this IoK8sApimachineryPkgApisMetaV1StatusCause.
        :type message: str
        """

        self._message = message

    @property
    def reason(self) -> str:
        """Gets the reason of this IoK8sApimachineryPkgApisMetaV1StatusCause.

        A machine-readable description of the cause of the error. If this value is empty there is no information available.  # noqa: E501

        :return: The reason of this IoK8sApimachineryPkgApisMetaV1StatusCause.
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason: str):
        """Sets the reason of this IoK8sApimachineryPkgApisMetaV1StatusCause.

        A machine-readable description of the cause of the error. If this value is empty there is no information available.  # noqa: E501

        :param reason: The reason of this IoK8sApimachineryPkgApisMetaV1StatusCause.
        :type reason: str
        """

        self._reason = reason
